#!/usr/bin/env python

#	Skymeter, raadpleegt de Volumepagina van skynet selfcare,
#	verwerkt deze en bekomt de nuttige informatie.
#	
#	Copyright (C) 2005 Thomas Langewouters. 
#	
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#	
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import Tkinter
import tkSimpleDialog
import tkMessageBox
import tkSimpleDialog
from skymeter import skymeter, skymetererror

class SimpleBar:
	width = 200
	height = 25

	def __init__(self, parentwidget):
		self.widget = Tkinter.Canvas(parentwidget, width="200", height="25")
		self.SetState(False)

	def SetState(self, state):
		self.widget.create_rectangle(0,0,self.width, self.height, fill="black")
		if state:
			self.widget.create_rectangle(1,1,self.width-2, self.height-2, fill="yellow")
		else:
			self.widget.create_rectangle(1,1,self.width-2, self.height-2, fill="grey")

	def SetValue(self, decimal):
		self.SetState(True)
		self.widget.create_rectangle(1,1,(self.width - 2)* decimal, self.height - 2, fill="blue")


class ConfDialog(tkSimpleDialog.Dialog):
	def body(self, master):
		Tkinter.Label(master, text="Username:").grid(row=0)
		Tkinter.Label(master, text="Password:").grid(row=1)
		self.e1 = Tkinter.Entry(master)
		self.e2 = Tkinter.Entry(master)
		self.e1.grid(row=0, column=1)
		self.e2.grid(row=1, column=1)
		self.username = ""
		self.password = ""
		self.changed = False
		return self.e1 # initial focus

	def apply(self):
		self.username = self.e1.get()
		self.password = self.e2.get()
		self.changed = True
		

class TkSkymeter(skymeter):
	username = ""
	password = ""
	
	def mnu_PollMeter(self):
		if self.username != "" and self.password != "":
			result = self.GetData()
			if isinstance(result, skymetererror):
				tkMessageBox.showwarning("Fout bij het raadplegen van skymeter: ", result.error)
			else:
				self.updatebars(result)	
		else:
			tkMessageBox.showwarning("Fout","Gebruikersnaam of wachtwoord niet opgegeven,\nKlik op Instellingen en geef uw gebruikersnaam/wachtwoord in.")
			
	def updatebars(self, result):
		self.BasicBar.SetValue(result["basic"][0] / result["basic"][1])
		self.BasicVal.set( "%2.2f van %2.2f GB" % tuple(result["basic"]))

		if result["pack"] != []:
			self.PackBar.SetValue(result["pack"][0] / result["pack"][1])
			self.PackVal.set( "%2.2f van %2.2f GB" % tuple(result["pack"]))
		else:	
			self.PackBar.SetState(False)
			self.PackVal.set("Geen lopende volumepack")

	def mnu_Settings(self):
		Cdia = ConfDialog(self.root)

		if Cdia.changed:
			self.username = Cdia.username
			self.password = Cdia.password

	def mnu_About(self):
		tkMessageBox.showinfo("Over...","Geschreven door Thomas Langewouters\nGebruik op eigen risico")
	
	def main(self):
		self.root = Tkinter.Tk()		
		self.root.title("TkSkymeter - Skynet Volume Meter")
		#menubar
		self.menubar = Tkinter.Menu(self.root)
		self.menubar.add_command(label="Verversen", command=self.mnu_PollMeter)
		self.menubar.add_command(label="Instellingen", command=self.mnu_Settings)
		self.menubar.add_command(label="Over", command=self.mnu_About)
		self.root.config(menu=self.menubar)

		#Left Labels...
		self.lblbasic = Tkinter.Label(self.root, text="Basisvolume:")
		self.lblbasic.grid(row=0)
		self.lblpack = Tkinter.Label(self.root, text="Volumepack:")
		self.lblpack.grid(row=1)
		
		#progress bars	
		self.BasicBar = SimpleBar(self.root)
		self.BasicBar.widget.grid(row=0, column=1)
		self.PackBar = SimpleBar(self.root)
		self.PackBar.widget.grid(row=1, column=1)

		#Left Labels...
		self.BasicVal = Tkinter.StringVar()
		self.BasicVal.set("?/?")
		self.PackVal = Tkinter.StringVar()
		self.PackVal.set("?/?")
		self.lblbasicval = Tkinter.Label(self.root, textvariable=self.BasicVal)
		self.lblbasicval.grid(row=0, column=2)
		self.lblpackval = Tkinter.Label(self.root, textvariable=self.PackVal)
		self.lblpackval.grid(row=1, column=2)

		# start mainloop
		self.root.mainloop()
		

main = TkSkymeter()
main.main()
